/**
 * @file  filedevicetext.h
 * @brief Schnittstelle fuer die Klasse FileDeviceText.
 */
//////////////////////////////////////////////////////////////////////
#ifndef FILEDEVICETEXT_H
#define FILEDEVICETEXT_H

// Basisklasse 
#include "fileintelhex.h"

// Strukturdefinitionen
#include "../Common/pzemaiv.h"
// CRC berechnungsroutinen
#include "../Common/crc.h"

#ifdef _MSC_VER
#pragma warning(disable : 4996)
#endif

class FileDeviceText : public FileIntelHex
{
public:
	FileDeviceText();
	virtual ~FileDeviceText();

public:
	void reset();
	inline unsigned int GetSizeData() { return (unsigned int)m_sizeData; };

	int Load( const std::string &filePath );
	int Save( const std::string &filePath, bool append = false );
	char *DefaultDFL();
	
	int Import(const std::string &filePath );
	int ParseLineFromHeader(char *data, unsigned short &id, char **format, char **text, unsigned int &flags);
	int ParseLineFromDefault(char *data, unsigned short &id, char **format, char **text, unsigned int &flags);
	void ConvertControlCharacters(char **text);

public:
	size_t m_sizeData;
	unsigned char *m_memData;
	unsigned int m_sizeDefaultDFL;
	char *m_memDefaultDFL;
};

#endif

